/*
=========================================================================================================================================================================================================================================
C:\
=       Status X           -  AMX Mod X script. Copyright © 2023, WATCH_DOGS UNITED.
=
=========================================================================================================================================================================================================================================
=
============================ ================================================================================================= ==========================================================================================================
=         Credits          | |                                        Credits Reason                                         | |                                               Web Address
============================ ================================================================================================= ==========================================================================================================
=                          | |                                                                                               | |
=  λMX Mod X               | | Plugin creation opportunity; © Copyright AMX Mod X Dev Team;                                  | | https://www.amxmodx.org
=  WATCH_DOGS UNITED       | | Plugin creation;                                                                              | | https://gamebanana.com/members/1725138
=  Cuttlas                 | | Plugin creation request and bug reporting.                                                    | | https://forums.alliedmods.net/member.php?u=257185
=                          | |                                                                                               | |
============================ ================================================================================================= ==========================================================================================================
=
================
=  Description |
================
=
=  Use this plugin if you want to specify if the enemy, teammate, or hostage status will be visible for a specific team when aiming.
=
=  Below are some of the consequences of disabling status:
=
=  Disabling status could make it harder for the player to conclude who/what ()e's aiming in the darkness or other sort of obfuscation;
=  Disabling status may give more concentration and naturality, or realism for the game;
=  Disabling status may reduce CPU usage by a bit due to the long strings removal;
=  Disabling status may reduce visual chaos;
=  Disabling status may produce a more innovative gameplay.
=
=  The sense of it's configuration is up to the plugin's user.
=
================
=  Commands    |
================
=
=  sts_ct            -  Specifies the team status available for Counter-Terrorists. 3 = Both team status; 2 = Counter-Terrorists; 1 = Terrorists; 0 = None. Default: 3 ( Both )
=  sts_t             -  Specifies the team status available for         Terrorists. 3 = Both team status; 2 = Counter-Terrorists; 1 = Terrorists; 0 = None. Default: 3 ( Both )
=
=  sts_hg            -  Specifies the hostage status availability for a team. 3 = Both teams; 2 = only for Counter-Terrorists; 1 = only for Terrorists. 0 = None of them. Default: 3 ( Both )
=
=  Note:             -  Currently, when a cvar is changed, it will have effect as soon as the player aims to the opposed team or the hostages.
=
=========================================================================================================================================================================================================================================
=  Changelog   |
================
=
=  Dec 04, 2023 - v1.0     -  Initial release.
=  Dec 05, 2023 - v1.1     -  Fixed some issues.
=
=      [ FIXED ]           -  Fixed wrong check for terrorists.
=      [ FIXED ]           -  Replaced the way of checking for valid clients by a conventional way. The detection of the quitter id was incorrect and could exclude some clients.
=
=========================================================================================================================================================================================================================================
*/

#include <amxmodx>

#define joiner (clients)
#define quitter (clients + 1)
#define valid(%0) (31 >= %0 > 0)
#define num get_pcvar_num
#define FRIEND (i_team == tgt_team)
#define ENEMY (i_team != tgt_team)

new Option[3]    // pcvars for easily changing settings.

static target    // variable to store the targeted entity id.
static body      // variable to store the targeted body hitplace id.

static hostage   // variable to store the hostage check result.

static i_team    // variable to store the message receiver team.
static tgt_team  // variable to store the targeted player team.

static var_CT    // variable to store the Counter-Terrorist's cvar setting.
static var_T     // variable to store the Terrorist's cvar setting.
static var_HG    // variable to store the Hostage's cvar setting.

public plugin_init()
{
	register_plugin("Status X","1.1","WATCH_DOGS UNITED")

	Option[0] = register_cvar("sts_ct", "3")
	Option[1] = register_cvar("sts_t" , "3")
	Option[2] = register_cvar("sts_hg", "3")

	register_message(get_user_msgid("StatusText"), "Event_Status_X")
}

public Event_Status_X(msg_id, msg_dest, id)
{
	if(valid(id))                             // Checks if the value of id refers to a possible client id.
	                                          // This way, we are not attributing/causing anything to a non player entity, which will save CPU and RAM, and avoid errors.
	{
		get_user_aiming(id,target,body,9999)

		hostage = (target > 31 && body)       // Only players and hostages gets a print, so if targeted ent_id is above max clients (non player) <and> this entity has a body hitplace (body > 0), then, we've found a hostage.

		if (valid(target) || hostage)
		{
			tgt_team = get_user_team(target)  //
			i_team = get_user_team(id)        //
                                              // Here we are caching the values obtained by the natives <in the current call> in the variables so we do not need to call the natives (procedures) again in the next checks below:
			var_CT = num(Option[0])           //
			var_T  = num(Option[1])           //
			var_HG = num(Option[2])           //

			if (!body ||                      // Unsure if really works, but this could make the print detection of body more accurate.

			    i_team == 2 && ((!var_CT || var_CT == 2 && ENEMY  || var_CT == 1 && FRIEND ) && !hostage || hostage && ((1<<0 | 1<<1) & (1<<var_HG))) ||  // CT checks.
			    i_team == 1 && ((!var_T  || var_T  == 2 && FRIEND || var_T  == 1 &&  ENEMY ) && !hostage || hostage && ((1<<0 | 1<<2) & (1<<var_HG))) )   //  T checks.
			{
				set_msg_arg_string(2, "")     // replaces the printed string of the targeted player status by an empty string.

				target = body = hostage = i_team = tgt_team = var_CT = var_T = var_HG = 0               // clears uneeded data after the sucessfull operation. Data is re-gathered and re-eliminated in the next call.
			}
		}
	}
}